
#define ENABLE_GAMMA_CORRECTION

// Global Includes

#define DISABLE_TEXTURE_0
#include "../include/PostFX.fxh"

// constants

float4 cToneMappingData;		/// x=MaxWhiteKeySquared, y=Exposure

// sampler

DEFINETEXTURE2D_SRGB(cTexture0, sTexture0, LINEAR, CLAMP);

// Shader vs_Object_p0

struct vs_Object_p0_input
{
	float3 Position0 : S_POSITION(0);
	float2 TexCoord0 : S_TEXCOORD(0);
};

struct vs_Object_p0_output
{
	float4 Position0 : S_POSITION(0);
	float2 TexCoord0 : S_TEXCOORD(0);
};

void vs_Object_p0(in vs_Object_p0_input Input0, out vs_Object_p0_output Output5)
{
	Output5.Position0 = float4(Input0.Position0, 1);
	Output5.TexCoord0 =	Input0.TexCoord0 + cUsrConstant0.xy * PIXEL_OFFSET * 2;
}

// Shader ps_Object_p0

struct ps_Object_p0_input
{
	float4 Position0 : S_POSITION(0);
	float2 Value0 : S_TEXCOORD(0);
};

struct ps_Object_p0_output
{
	float4 Color0 : S_TARGET(0);
};

void ps_Object_p0(in ps_Object_p0_input Input0, out ps_Object_p0_output Output3)
{
	Output3.Color0 = float4(0, 0, 0, 1);
	
//	const float max_i = 1;
//	const float half_max_i = floor(max_i / 2);
	//const float weights[max_i] = { 0.21, 0.26, 0.33, 0.41, 0.51, 0.64, 0.8, 1.0, 0.8, 0.64, 0.51, 0.41, 0.33, 0.26, 0.21 };
	//const float weights[max_i] = { 0.125, 0.25, 0.5, 1.0, 0.5, 0.25, 0.125 };
	//const float weights[max_i] = { 0.03, 0.05, 0.1, 0.2, 1.0, 0.2, 0.1, 0.05, 0.03 };
	//	const float weights[max_i] = { 0.05, 0.1, 0.15, 0.2, 0.3, 0.2, 0.15, 0.1, 0.05 };
	

//		float2 TexCoord = Input0.Value0 + cUsrConstant0.xy * (i - half_max_i) * cUsrConstant1.xy * 2;// * 0.5

//		float4 Sample = SAMPLETEXTURE2D(cTexture0, sTexture0, TexCoord);

//		DecodeHDR(Sample.rgb);
		
//		Output3.Color0.rgb += Sample.rgb;

	
	//Output3.Color0.rgb /= 1.96;
	//Output3.Color0.rgb /= 7.32;
	//Output3.Color0.rgb /= 2.75;
	//Output3.Color0.rgb /= 1.76;

//	EncodeHDR(Output3.Color0.rgb);
}

// Techniques

METHOD Object <string format = "p3t2";>
{
	pass p0
	{
		SETSTATES(postfx);
		SETVERTEXSHADER(vs_max, vs_Object_p0());
		DISABLEGEOMETRYSHADER;
		SETPIXELSHADER(ps_max, ps_Object_p0());
	}
}

/*
#define DOWNSAMPLING2x2_HW_FILTERING 0

void VS_Downsampling(in VS_INPUT_PT In,

			         out float4 oPosition	: POSITION,
			         out float2 oTexCoord0	: TEXCOORD0)
{
	oPosition = float4(In.Position, 1);
	
	oTexCoord0 = In.TexCoord0;// + vcUsrConstant0.xy * 0.5;
	
	// falls HW Filtering nicht geht: noch eine halbe Pixelgre als Offset drauf addieren
	#ifndef DOWNSAMPLING2x2_HW_FILTERING
		oTexCoord0 *= 1 - vcUsrConstant0.xy*0.5;
		oTexCoord0 += vcUsrConstant0.xy * 0.5;
	#else
		//oTexCoord0 *= 1 + vcUsrConstant0.xy*0.5;
		oTexCoord0 += vcUsrConstant0.xy;//*0.5;//*1.5;// * 1.25;
	#endif
}


void PS_Downsampling(in float2 iTexCoord0	: TEXCOORD0,

                     out float4 oColor		: COLOR)
{
	//#ifdef DOWNSAMPLING2x2_HW_FILTERING
		// falls HW Filtering klappt: einfach in die Mitte der 4 Pixel samplen
	//	oColor.rgba = tex2D(samplerTex0, iTexCoord0);
	//#else
		// falls HW Filtering nicht klappt: manuell die 4 Pixel samplen und mitteln
		float4 ColorSum = 0;
		
		for(float j=-3; j<4; j+=2)
		{
			for(float i=-3; i<4; i+=2)
			{
				float2 newTexCoord = iTexCoord0 + vcUsrConstant0.xy * float2(i, j);//*0.5;
				
				//float WeightFactor = 1 - (abs(i * j) / 10);
				float WeightFactor = abs(1 / (i * j));
				float4 Sample = tex2D(samplerTex0, newTexCoord);
				ColorSum += Sample * WeightFactor;
			}
		}
		
		oColor.rgba = ColorSum / 10.45;//9.6;	// 9.6 = 4*0.1 + 8*0.7 + 4*0.9
	//#endif

	//oColor.rgba = Downsampling2x2(samplerTex0, iTexCoord0, vcUsrConstant0.xy);
}
*/